/* global Bdf,$$,ID,Transformation,CodeMirror,Pane */

Transformation.MetadataForm = {};

Transformation.MetadataForm.load = function (templateKey) {
    var templateDescription = Transformation.getTemplateDescription(templateKey);
    if (!templateDescription) {
        return;
    }
    var isInStock = false;
    var formId = Bdf.generateId();
    var attributesId = formId + "_attributes";
    $$("layout_main").html(Bdf.render("transformation:metadataform", {
        action: Bdf.URL + "exportation",
        formId: formId,
        templateKey: templateKey,
        split: Transformation.split(templateKey),
        title: templateDescription.title,
        labelArray: Bdf.toLabelArray(templateDescription.labelMap),
        labelsLocKey: "_ title.exportation.templatelabels",
        attributes: Bdf.attrMapToString(templateDescription.attrMap),
        attributesLocKey: "_ title.exportation.templateattributes",
        attributesId: attributesId,
        commandKey: "EXP-33",
        commandUrl: Bdf.getCommandUrl("EXP-33")
    }));
    $$(formId, "button_stock").click(function () {
        Pane.moveMainToStock();
    });
    $$(formId).ajaxForm({
        beforeSerialize: function ($form, options) {
            if (isInStock) {
                return false;
            } else {
                attributesCodeMirror.save();
                return true;
            }
        },
        dataType: "json",
        success: function (data, textStatus, jqXHR, $form) {
            Pane.setChange(false);
            _saveCallback(data);
        }
    });
    var attributesCodeMirror = Bdf.toCodeMirror(ID(attributesId), {
        lineWrapping: false,
        lineNumbers: false,
        indentUnit: 4,
        theme: 'bdf',
        mode: "attributes"
    });
    attributesCodeMirror.on("change", function () {
        Pane.setChange(true);
    });
    $$(formId).data("stockHandler", _stockHandler);
    Pane.checkState();

    
    function _saveCallback(data) {
        if (Bdf.isError(data)) {
            return;
        }
        Bdf.showCommandMessage(data.commandMessage);
        if (data.commandMessage.type === "done") {
            Bdf.updateDefaultValues($$(formId));
            let newtemplateDescription = Transformation.updateTemplateDescription(data.templateDescription);
            Bdf.$($$(formId), {role: "metadata-title"}).html(newtemplateDescription.title);
        }
    }
    
    function _stockHandler(stock) {
        isInStock = stock;
        attributesCodeMirror.setOption("readOnly", stock);
        Pane.setReadOnly($$(formId), stock);
    }
    
};